SystemOrganization addCategory: #'tODE-Core'!

!Object methodsFor: '*tode-core' stamp: 'dkh 5/29/2011 13:45'!
asTOBookmark

	^TOBookmark new object: self! !

!Object methodsFor: '*tode-core' stamp: 'dkh 6/16/2011 03:43'!
renderViewContentOn: html main: main
	html strong: self printString
! !

!Object methodsFor: '*tode-core' stamp: 'dkh 6/16/2011 03:44'!
renderViewContentOn: html spec: aTOTabSpec main: main

	aTOTabSpec renderer renderViewContentOn: html main: main! !

!Object methodsFor: '*tode-core' stamp: 'dkh 05/21/2011 07:29'!
tODEFrameClassFor: aTOSession

	^aTOSession defaultObjectFrameClass! !

!Object methodsFor: '*tode-core' stamp: 'dkh 6/14/2011 08:39'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #view;
		receiver: self;
		label: 'view';
		order: 5;
		group: 'basic';
		renderSelector: #renderViewContentOn:spec:main:! !

Object subclass: #TOBookmark
	instanceVariableNames: 'object label tab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOBookmark methodsFor: 'converting' stamp: 'dkh 5/29/2011 13:46'!
asTOBookmark

	^self! !

!TOBookmark methodsFor: 'testing' stamp: 'dkh 5/30/2011 09:06'!
isExternal
	^false! !

!TOBookmark methodsFor: 'accessing' stamp: 'dkh 5/29/2011 13:33'!
label
	label ifNil: [^self object printStringLimitedTo: 50  ].
	^ label! !

!TOBookmark methodsFor: 'accessing' stamp: 'dkh 5/29/2011 13:32'!
label: anObject
	label := anObject! !

!TOBookmark methodsFor: 'accessing' stamp: 'dkh 5/29/2011 13:32'!
object
	^ object! !

!TOBookmark methodsFor: 'accessing' stamp: 'dkh 5/29/2011 13:32'!
object: anObject
	object := anObject! !

!TOBookmark methodsFor: 'accessing' stamp: 'dkh 5/29/2011 13:36'!
tab

	tab ifNil: [^#inspect ].
	^ tab! !

!TOBookmark methodsFor: 'accessing' stamp: 'dkh 5/29/2011 13:35'!
tab: anObject
	tab := anObject! !

TOBookmark subclass: #TOExternalBookmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOExternalBookmark methodsFor: 'testing' stamp: 'dkh 5/30/2011 09:07'!
isExternal
	^true! !

Object subclass: #TOObject
	instanceVariableNames: 'object properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 17:19'!
actualClass

	^self object class! !

!TOObject methodsFor: 'evaluation' stamp: 'dkh 6/4/2011 15:32'!
doit: aString main: main
	^ main currentSystem
		evaluate: aString
		in: nil
		to: self object
		notifying: nil
		ifFail: [  ]! !

!TOObject methodsFor: 'evaluation' stamp: 'dkh 5/28/2011 13:34'!
inspectit: aString main: main

	self pushit: (self doit: aString main: main) selecting: #inspect main: main! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
object
	^ object! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
object: anObject
	object := anObject! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
properties

	properties ifNil: [ properties := Dictionary new ].
	^ properties! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
properties: anObject
	properties := anObject! !

!TOObject methodsFor: 'evaluation' stamp: 'dkh 6/3/2011 13:44'!
pushit: anObject selecting: aSymbol main: main

	main currentSession push: anObject selecting: aSymbol! !

!TOObject methodsFor: 'rendering' stamp: 'dkh 5/28/2011 08:43'!
renderButton: renderBlock label: label on: html
	(html submitButton)
		onClick: (html jQuery ajax script: [ :s | renderBlock value: s ]);
		with: label! !

!TOObject methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:15'!
renderControl: aBlock on: html
	| id |
	id := html nextId.
	html fieldSet: [
		html span: [
			aBlock
				value: id
				" update the paragraph "
				value: ((html jQuery this	
					parents: 'fieldset';
					find: 'p') load
						" serialize all nearby form elements "
						serialize: (html jQuery this		
							parents: 'span';
							find: ':input')) ]]! !

!TOObject methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:15'!
renderLink: block with: labelRenderer on: html

	| id |
	id := html nextId.
	(html anchor)
		url: '#';
		id: id;
		onClick:
			(html jQuery ajax
				script: [ :s | block value: s ]);
		with: labelRenderer! !

TOObject subclass: #TOObjectFrame
	instanceVariableNames: 'selectedCenterTab centerTabSpec label session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOObjectFrame methodsFor: 'private' stamp: 'dkh 6/14/2011 09:53'!
calculateCenterTabSpec
	| currentObject specs groups grouped ids |
	currentObject := self object.
	ids := IdentitySet new.
	specs := (self session currentSystem
		tabSpec: #tODEFrameTabSpec
		in: self class
		for: self
		frame: self)
		,
			(self session currentSystem
				tabSpec: #tODECenterTabSpec
				from: currentObject class
				to: nil
				for: currentObject
				frame: self).
	specs := specs
		select: [ :each | 
			(ids includes: each id)
				ifTrue: [ false ]
				ifFalse: [ 
					ids add: each id.
					true ] ].
	groups := (specs collect: [ :ea | ea group ]) asSet asSortedCollection: [ :a :b | a < b ].
	grouped := groups
		collect: [ :ea | (specs select: [ :b | b group = ea ]) asSortedCollection: [ :a :b | a order <= b order ] ].
	^ grouped gather: [ :ea | ea ]! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/22/2011 17:50'!
centerTabSpec

	centerTabSpec ifNil: [ centerTabSpec := self calculateCenterTabSpec ].
	^centerTabSpec ! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 6/3/2011 16:59'!
currentSession
	^ self session! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:24'!
historyLabel

	^self object printStringLimitedTo: 50! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:43'!
label

	label ifNil: [ label := 'tODE frame'].
	^label! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:18'!
label: aString

	label := aString! !

!TOObjectFrame methodsFor: 'as yet unclassified' stamp: 'dkh 6/16/2011 04:17'!
printOn: aStream
	super printOn: aStream.
	(self object isKindOf: self)
		ifFalse: [ 
			aStream
				nextPut: $(;
				nextPutAll: self object printString;
				nextPut: $) ]! !

!TOObjectFrame methodsFor: 'rendering' stamp: 'dkh 6/3/2011 15:50'!
renderFrame: index on: html main: main
	self
		renderLink: [ :s | 
			self currentSession push: self object selecting: self selectedCenterTab.
			main updateCenterSideHistory: s ]
		with: [ html strong: index printString , '. ' ]
		on: html.
	html text: self historyLabel! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/29/2011 10:37'!
rendererForCenterTab: aSymbol
	self centerTabSpec
		do: [ :spec | 
			spec id == aSymbol
				ifTrue: [ ^ spec renderer ] ].
	^ nil! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:43'!
selectedCenterTab

	^selectedCenterTab ! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:43'!
selectedCenterTab: aSymbol

	^selectedCenterTab := aSymbol! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:43'!
selectedCenterTabIndex
	| selectedTab |
	selectedTab := self selectedCenterTab.
	self centerTabSpec
		withIndexDo: [ :spec :i | 
			spec id == selectedTab
				ifTrue: [ ^ i - 1 ] ].
	^ 0! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 6/3/2011 15:14'!
session
	^ session! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 6/3/2011 15:14'!
session: anObject
	session := anObject! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:59'!
sidebarSpec
	| specs |
	specs := (self centerTabSpec at: self selectedCenterTabIndex + 1) sidebarSpec.
	specs do: [:spec | spec frame: self ].
	^specs! !

TOObject subclass: #TORenderer
	instanceVariableNames: 'frame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

TORenderer subclass: #TOHome
	instanceVariableNames: ''
	classVariableNames: 'HomeClass'
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOHome class methodsFor: 'registration' stamp: 'dkh 05/21/2011 06:22'!
homeClass

	HomeClass ifNil: [ ^self ].
	^ HomeClass! !

!TOHome class methodsFor: 'registration' stamp: 'dkh 05/21/2011 06:20'!
homeClass: aClass

	HomeClass := aClass! !

!TOHome class methodsFor: 'registration' stamp: 'dkh 05/21/2011 06:20'!
select
	TOHome homeClass: self! !

!TOHome class methodsFor: 'registration' stamp: 'dkh 05/21/2011 06:21'!
unselect
	TOHome homeClass = self ifTrue: [ TOHome homeClass: nil ]! !

!TOHome methodsFor: 'accessing' stamp: 'dkh 6/15/2011 14:43'!
bookmark: anObject

	^self bookmarks add: anObject asTOBookmark! !

!TOHome methodsFor: 'accessing' stamp: 'dkh 6/15/2011 14:43'!
bookmarks

	^TORoot current bookmarks! !

!TOHome methodsFor: 'accessing' stamp: 'dkh 6/15/2011 18:11'!
expressions

	^TORoot current expressions! !

!TOHome methodsFor: 'accessing' stamp: 'dkh 5/29/2011 13:55'!
removeBookmark: bookmark

	self bookmarks remove: bookmark! !

!TOHome methodsFor: 'rendering' stamp: 'dkh 05/21/2011 06:43'!
renderBookmarksOn: html main: main
	self bookmarks reversed
		do: [ :bookmark | 
			self
				renderLink: [ :s | 
							self currentSession push: bookmark selecting: #inspect.
							main updateCenterSideHistory: s ]
				with: 'b'
				on: html.
			html
				space;
				space.
			self
				renderLink: [ :s | 
					self removeBookmark: bookmark.
					main updateCenterOn: s ]
				with: 'x'
				on: html.
			html
				space;
				space.
			bookmark isExternal
				ifTrue: [ 
					(html anchor)
						url: bookmark object;
						with: bookmark label, ' (external)' ]
				ifFalse: [ 
					self
						renderLink: [ :s | 
							self currentSession push: bookmark object selecting: bookmark tab.
							main updateCenterSideHistory: s ]
						with: bookmark label
						on: html ].
			html break ]! !

!TOHome methodsFor: 'rendering' stamp: 'dkh 6/15/2011 14:58'!
renderControlsOn: html main: main
	self
		renderButton: [ :s |
			TORoot reset.
			main updateCenterSideHistory: s ]
		label: 'RESET root'
		on: html.
	html break.
	self
		renderButton: [ :s | | sessionName |
			sessionName := main currentSession name.
			TORoot current sessions removeKey: sessionName ifAbsent: [].
			main currentSession: (TORoot current sessionNamed:  sessionName).
			main updateCenterSideHistory: s ]
		label: 'RESET session'
		on: html.
! !

!TOHome methodsFor: 'rendering' stamp: 'dkh 6/14/2011 08:29'!
renderViewContentOn: html spec: aTOTabSpec main: main
	html strong: 'tOde operations:'.
	html unorderedList: [self renderControlsOn: html main: main].
	html strong: 'Bookmarks:'.
	html unorderedList: [self renderBookmarksOn: html main: main].
! !

!TORenderer methodsFor: 'accessing' stamp: 'dkh 05/21/2011 06:41'!
currentSession

	^self frame currentSession! !

!TORenderer methodsFor: 'accessing' stamp: 'dkh 05/21/2011 06:41'!
currentSystem

	^self currentSession currentSystem! !

!TORenderer methodsFor: 'accessing' stamp: 'dkh 05/21/2011 06:41'!
frame

   "Return the value of the instance variable 'frame'."
   ^frame
! !

!TORenderer methodsFor: 'accessing' stamp: 'dkh 05/21/2011 06:41'!
frame: newValue

   "Modify the value of the instance variable 'frame'."
   frame := newValue
! !

Object subclass: #TORoot
	instanceVariableNames: 'bookmarks expressions sessions'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'tODE-Core'!

!TORoot class methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:35'!
current

	Current ifNil: [ Current := self new ].
	^Current ! !

!TORoot class methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:35'!
reset
	"self reset"

	Current := nil! !

!TORoot methodsFor: 'accessing' stamp: 'dkh 6/15/2011 14:41'!
bookmarks

	bookmarks ifNil: [ bookmarks := OrderedCollection new. ].
	^ bookmarks! !

!TORoot methodsFor: 'accessing' stamp: 'dkh 6/15/2011 17:05'!
currentSession 

	^self sessionNamed: TOSession defaultSessionName! !

!TORoot methodsFor: 'accessing' stamp: 'dkh 6/15/2011 18:10'!
expressions

	expressions ifNil: [ expressions := OrderedCollection new. ].
	^ expressions! !

!TORoot methodsFor: 'accessing' stamp: 'dkh 6/15/2011 12:52'!
sessionNamed: aString

	^self sessions at: aString ifAbsent: [ self sessions at: aString put: ((TOSession new) name: aString; yourself)]! !

!TORoot methodsFor: 'accessing' stamp: 'dkh 6/15/2011 12:37'!
sessions

	sessions ifNil: [ sessions := Dictionary new. ].
	^ sessions! !

Object subclass: #TOSession
	instanceVariableNames: 'name currentFrame currentSystem history frameStack frameStackIndex inverseFrameMap homeObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOSession class methodsFor: 'accessing' stamp: 'dkh 6/15/2011 17:03'!
defaultSessionName

^'0'! !

!TOSession methodsFor: 'frame operations' stamp: 'dkh 5/28/2011 09:31'!
back
	"set the currentFrame to the previous frame on the frame stack and record in history"

	| frame |
	self frameStackIndex <= 1 ifTrue: [ ^currentFrame ].
	frameStackIndex := self frameStackIndex - 1.
	frame := self frameStack at: frameStackIndex.
	self history addLast: frame.
	^currentFrame := frame! !

!TOSession methodsFor: 'frame operations' stamp: 'dkh 5/29/2011 13:38'!
bookmark

	| bookmark |
	bookmark := self homeObject bookmark: self currentFrame object.
	bookmark tab: self currentFrame selectedCenterTab! !

!TOSession methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:24'!
currentFrame
	currentFrame
		ifNil: [ currentFrame := self pushFrame: self homeFrame ].
	^ currentFrame! !

!TOSession methodsFor: 'accessing' stamp: 'dkh 6/3/2011 14:26'!
currentSystem

	currentSystem ifNil: [ currentSystem := TOSystem current ].
	^ currentSystem! !

!TOSession methodsFor: 'accessing' stamp: 'dkh 6/3/2011 14:25'!
currentSystem: anObject
	currentSystem := anObject! !

!TOSession methodsFor: 'accessing' stamp: 'dkh 05/21/2011 07:31'!
defaultObjectFrameClass

	^TOObjectFrame! !

!TOSession methodsFor: 'accessing' stamp: 'dkh 6/15/2011 18:24'!
expressions

	^TORoot current expressions! !

!TOSession methodsFor: 'private' stamp: 'dkh 5/22/2011 18:58'!
findFrameFor: anObject
	^self inverseFrameMap
		at: anObject
		ifAbsent: [ 
			self inverseFrameMap
				at: anObject
				put:
					(self newFrameFor: anObject) ].
! !

!TOSession methodsFor: 'frame operations' stamp: 'dkh 5/28/2011 09:26'!
forward
	"set the currentFrame to the next frame on the frame stack and record in history"

	| frame |
	self frameStack size = self frameStackIndex ifTrue: [ ^currentFrame ].
	frameStackIndex := self frameStackIndex + 1.
	frame := self frameStack at: frameStackIndex.
	self history addLast: frame.
	^currentFrame := frame! !

!TOSession methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:01'!
frameStack
	
	frameStack ifNil: [frameStack := OrderedCollection new ].
	^frameStack ! !

!TOSession methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:06'!
frameStackIndex

	frameStackIndex ifNil: [ frameStackIndex := self frameStack size ].
	^frameStackIndex! !

!TOSession methodsFor: 'accessing' stamp: 'dkh 5/22/2011 16:57'!
history
	
	history ifNil: [history := OrderedCollection new ].
	^history ! !

!TOSession methodsFor: 'frame operations' stamp: 'dkh 5/28/2011 09:18'!
home
	"push the home frame on the frame stack and record in history"

	^self pushFrame: self homeFrame! !

!TOSession methodsFor: 'accessing' stamp: 'dkh 6/14/2011 08:24'!
homeFrame

	| fr ho |
	fr := self findFrameFor: (ho := self homeObject).
	ho frame: fr.
	fr selectedCenterTab ifNil: [ fr selectedCenterTab: #view ].
	^fr! !

!TOSession methodsFor: 'accessing' stamp: 'dkh 05/21/2011 06:21'!
homeObject
	homeObject ifNil: [ homeObject := TOHome homeClass new ].
	^ homeObject! !

!TOSession methodsFor: 'accessing' stamp: 'dkh 6/3/2011 14:50'!
homeObject: anObject
	homeObject := anObject! !

!TOSession methodsFor: 'accessing' stamp: 'dkh 5/22/2011 18:51'!
inverseFrameMap

	inverseFrameMap ifNil: [ inverseFrameMap := IdentityDictionary new ].
	^inverseFrameMap! !

!TOSession methodsFor: 'accessing' stamp: 'dkh 6/15/2011 17:04'!
name
	name ifNil: [ name := self class defaultSessionName ].
	^ name! !

!TOSession methodsFor: 'accessing' stamp: 'dkh 6/15/2011 12:31'!
name: anObject
	name := anObject! !

!TOSession methodsFor: 'private' stamp: 'dkh 05/21/2011 07:32'!
newFrameFor: anObject
	^ ((anObject tODEFrameClassFor: self) new)
		object: anObject;
		session: self;
		yourself! !

!TOSession methodsFor: 'printing' stamp: 'dkh 6/15/2011 14:48'!
printOn: aStream


	super printOn: aStream.
	aStream 
		nextPut: $(;
		nextPutAll: self name;
		nextPut: $)  ! !

!TOSession methodsFor: 'frame operations' stamp: 'dkh 5/28/2011 09:18'!
push: anObject
	"push the frame for anObject onto the frameStack and record in history"

	^self pushFrame: (self findFrameFor: anObject)! !

!TOSession methodsFor: 'frame operations' stamp: 'dkh 5/28/2011 11:02'!
push: anObject selecting: aSymbol
	"push the frame for anObject onto the frameStack and record in history"

	| fr |
	fr := self findFrameFor: anObject.
	fr selectedCenterTab: aSymbol.  
	^self pushFrame: fr! !

!TOSession methodsFor: 'private' stamp: 'dkh 5/28/2011 09:17'!
pushFrame: frame
	"push the frame onto the frameStack and record in history"

	|  index |
	self history addLast: frame.
	(index := self frameStackIndex) = self frameStack size
		ifFalse: [ frameStack := frameStack copyFrom: 1 to: index ].
	self frameStack addLast: frame.
	frameStackIndex := index + 1.
	^currentFrame := frame! !

!TOSession methodsFor: 'frame operations' stamp: 'dkh 6/14/2011 08:31'!
search

	self push: TOSearch new selecting: #view! !

Object subclass: #TOSystem
	instanceVariableNames: ''
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOSystem class methodsFor: 'registration' stamp: 'dkh 6/3/2011 14:18'!
current

	^ Current! !

!TOSystem class methodsFor: 'registration' stamp: 'dkh 6/3/2011 14:18'!
current: aPlatform
	Current := aPlatform! !

!TOSystem class methodsFor: 'registration' stamp: 'dkh 6/3/2011 14:18'!
select
	TOSystem current: self new! !

!TOSystem class methodsFor: 'registration' stamp: 'dkh 6/3/2011 14:18'!
unselect
	TOSystem current class = self ifTrue: [ TOSystem current: nil ]! !

!TOSystem methodsFor: 'reflection' stamp: 'dkh 6/3/2011 16:00'!
allClasses

	^SystemNavigation default allClasses! !

!TOSystem methodsFor: 'reflection' stamp: 'dkh 6/3/2011 16:02'!
allClassesImplementing: aSelector

	^SystemNavigation default allClassesImplementing: aSelector! !

!TOSystem methodsFor: 'reflection' stamp: 'dkh 6/12/2011 17:25'!
allMethodsWithSourceString: aString matchCase: caseSensitive

	^SystemNavigation default allMethodsWithSourceString: aString matchCase: caseSensitive! !

!TOSystem methodsFor: 'reflection' stamp: 'dkh 6/12/2011 17:19'!
allReferencesTo: aSymbol

	^SystemNavigation default allReferencesTo: aSymbol! !

!TOSystem methodsFor: 'expression evaluation' stamp: 'dkh 6/3/2011 14:31'!
evaluate: textOrStream in: aContext to: receiver notifying: aRequestor ifFail: failBlock

	self subclassResponsibility ! !

!TOSystem methodsFor: 'classes' stamp: 'dkh 6/3/2011 16:03'!
methodReferenceClass

	^MethodReference! !

!TOSystem methodsFor: 'tab specs' stamp: 'dkh 6/3/2011 15:32'!
tabSpec: pragmaSelector from: aClass to: supClass for: receiver frame: aFrame
	^ (Pragma allNamed: pragmaSelector from: aClass to: supClass)
		collect: [ :pragma | 
			(receiver perform: pragma method selector)
				frame: aFrame;
				yourself ]! !

!TOSystem methodsFor: 'tab specs' stamp: 'dkh 6/3/2011 15:29'!
tabSpec: pragmaSelector in: aClass for: receiver frame: aFrame
	^ (Pragma allNamed: pragmaSelector in: aClass)
		collect: [ :pragma | 
			(receiver perform: pragma method selector)
				frame: aFrame;
				yourself ]! !

Object subclass: #TOTabSpec
	instanceVariableNames: 'id label group order priority renderSelector frame receiver sidebarSpec renderer rendererClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:08'!
frame
	^ frame! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 6/14/2011 10:06'!
frame: aFrame
	frame := aFrame.
	renderer
		ifNotNil: [ 
			self register: renderer.
			renderer frame: self frame ].
! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:11'!
group
	^ group! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:11'!
group: anObject
	group := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
id
	^ id! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
id: anObject
	id := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
label
	^ label! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
label: anObject
	label := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:16'!
order
	^ order! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:16'!
order: anObject
	order := anObject! !

!TOTabSpec methodsFor: 'printing' stamp: 'dkh 5/26/2011 11:47'!
printOn: aStream

	super printOn: aStream.
	aStream 
		nextPut: $(;
		nextPutAll: self label;
		nextPut: $)! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:06'!
receiver
	^ receiver! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/23/2011 23:06'!
receiver: anObject
	receiver := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 6/14/2011 09:56'!
register: aRenderer
	^self frame properties at: self id put: aRenderer! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:00'!
renderSelector
	^ renderSelector! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:00'!
renderSelector: anObject
	renderSelector := anObject! !

!TOTabSpec methodsFor: 'rendering' stamp: 'dkh 5/29/2011 10:30'!
renderTabSpecContentOn: html main: main
	self receiver
		perform: self renderSelector
		withArguments:
			{html.
			self.
			main}! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 6/14/2011 10:06'!
renderer
	renderer
		ifNil: [ 
			self rendererClass ifNil: [ ^ self receiver ].
			^ self frame properties
				at: self id
				ifAbsent: [ 
					self
						register:
							(renderer := (self rendererClass new)
								object: self receiver;
								frame: self frame;
								yourself) ] ].
	^ renderer! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/29/2011 10:35'!
renderer: anObject
	renderer := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/29/2011 10:35'!
rendererClass
	^ rendererClass! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/29/2011 10:35'!
rendererClass: anObject
	rendererClass := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:38'!
sidebarSpec
	sidebarSpec ifNil: [ ^#() ].
	^ sidebarSpec! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/26/2011 11:38'!
sidebarSpec: anObject
	sidebarSpec := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:59'!
tabLabel
	
	label ifNil: [ ^self id asString ].
	^label! !
